// CFAG_WinTestDlg.cpp : implementation file
// modified by Jeff Platt 07/2007 to scroll names for the CFAG128128
/*

 Most of this code is from the original CFAG160160 code from the CrystalFontz forums. 
 I modified the initialize function, and replaced the "Tractor" button
 to initialize a scrolling marquee timer.
 
 Use  "screen.inc" made from my bitmap utility BmpDisplay.exe.
 Just open a monochrome bitmap -not too large for some reason../]
 and it will print out the hex bytes that make up the bitmap,
 starting from the top left and row by row. Copy the output
 to screen.inc.
 
 -Jeff Platt 2007
*/
#include "stdafx.h"
#include "CFAG_WinTest.h"
#include "CFAG_WinTestDlg.h"
#include "tractor_320_240.inc"
#include "screen.inc"
//Parallel port direct access stuff
#include "dlportio.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAX_ROWS	128  /* 1088 */

BOOL Scrolling;
long curRow;







/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)

	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCFAG_WinTestDlg dialog

CCFAG_WinTestDlg::CCFAG_WinTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCFAG_WinTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCFAG_WinTestDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCFAG_WinTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCFAG_WinTestDlg)
	DDX_Control(pDX, IDC_ADDRESS, m_address);
	DDX_Control(pDX, IDC_Shift_Slider, m_Shift_Slider);
	DDX_Control(pDX, IDC_Shift_Setting, m_Shift_Setting);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCFAG_WinTestDlg, CDialog)
	//{{AFX_MSG_MAP(CCFAG_WinTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_INITIALIZE, OnInitialize)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(ID_CLEAR, OnClear)
	ON_BN_CLICKED(ID_CHECKERBOARD, OnCheckerboard)
	ON_BN_CLICKED(ID_H_Stripes, OnHStripes)
	ON_BN_CLICKED(ID_V_Stripes, OnVStripes)
	ON_BN_CLICKED(ID_SET, OnSet)
	ON_BN_CLICKED(ID_Diagonals, OnDiagonals)
	ON_BN_CLICKED(ID_TRACTOR, OnTractor)
	ON_BN_CLICKED(ID_Logo, OnLogo)
	ON_CBN_EDITCHANGE(IDC_DEVICE, OnEditchangeDevice)
	ON_CBN_EDITCHANGE(IDC_ADDRESS, OnEditchangeAddress)
	ON_BN_CLICKED(ID_ShowText, OnShowText)
	ON_BN_CLICKED(ID_Clear_Text, OnClearText)
	ON_BN_CLICKED(ID_OnBaxter, OnOnBaxter)
	ON_BN_CLICKED(IDC_SECOND_LAYER_BUTTON, OnSecondLayerButton)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCFAG_WinTestDlg message handlers


// Global / Locals / Whatever they are now.
int
  last_shift;
int
  display_type; //0=CFAX12864A 1=CFAX12864C
int
  port_data_address; //0 => 0x378, 1 => 0x278. 2 => 0x3BC
int
  port_control_address; //port_data_address + 2
/////////////////////////////////////////////////////////////////////////////
#include "Splash_CFAG240128.inc"
#include "Sophie_240_128.inc"

const unsigned char Text_Screen[20][28]=
  {"012345678901234567890123456",  // 00
   "012345678901234567890123456",
   "012345678901234567890123456",
   "0123                    456",  // 01
   "0123 27 col by 20 lines 456",  // 02
   "0123    of 5x7 text     456",  // 03
   "0123   built-in font    456",  // 04
   "0123                    456",  // 05
   "012345678901234567890123456",  // 06
   "012345678901234567890123456",  // 07
   "012345678901234567890123456",  // 07
   "0123                   3456",  // 08
   "0123   ABCDEFGHIJKLM   3456",  // 09
   "0123   NOPQRSTUVWXYZ   3456",  // 10
   "0123   abcdefghijklm   3456",  // 11
   "0123   nopqrstuvwxyz   3456",  // 12
   "0123                   3456",  // 13
   "012345678901234567890123456",  // 15
   "012345678901234567890123456",  // 16
   "012345678901234567890123456"}; // 19
 
//========================================================================
typedef unsigned char ubyte;

// Here are the cable pinouts.
//
// PC  PC           Port  Display       Cable
// Pin Name         .bit  Function      Color
//
// 1   Strobe       2.0   Enable        Green						Black
// 14  /AutoFeed    2.1   CS            Green/Black					Brown/White
// 16  Init         2.2   RS            Orange/Black				Orange/White
// 17  SelectIn     2.3   reset         Red/Black
// * R/W is tied low
// 2   Data0        0.0   DB0           Yellow						Brown
// 3   Data1        0.1   DB1           Orange						Red
// 4   Data2        0.2   DB2           Black						Orange
// 5   Data3        0.3   DB3           Red							Yellow
// 6   Data4        0.4   DB4           Brown Green					
// 7   Data5        0.5   DB5           Blue						
// 8   Data6        0.6   DB6           Gray						
// 9   Data7        0.7   DB7           Dark Purple					
//
// Additional inputs available:
//
// PC  PC           Port  Display       Cable
// Pin Name         .bit  Function      Color
//
// 10  ACK          1.6   (unused)      White
// 11  BUSY         1.7   (unused)      Pink
// 12  PaperEmpty   1.5   (unused)      Light Green
// 13  Select       1.4   (unused)      Light Blue
// 15  Error        1.3   (unused)      Yellow/Black
//
// PC  PC           Port  Display       Cable
// Pin Name         .bit  Function      Color
//
// 18  Ground                           Brown/Black					Blue/White
// 19  Ground                           Blue/Black					Purple/White
// 20  Ground                           Gray/Black					Red/Black
// 21  Ground                           Dark Purple/Black			Orange/Black
// 22  Ground                           White/Black					Yellow/Black
// 23  Ground                           Pink/Black					Green/Black
// 24  Ground                           Light Green/Black			Gray/Black
// 25  Ground                           Light Blue/Black			Pink/Black



ubyte  control;  //value of "*port_control_address"

void Delay(void)
  {
  int delay;
  for(delay=160;delay--;);
  }

void ShortDelay(void)
  {
  int delay;
  for(delay=100;delay--;);
  }

#define DATA_ADDR (port_data_address)
#define CONT_ADDR (port_control_address)
  
//inverted at the port
#define SCLR_CS (DlPortWritePortUchar(CONT_ADDR,(control|=0x02)));(Sleep(20))
#define CLR_CS (DlPortWritePortUchar(CONT_ADDR,(control|=0x02)))
#define SET_CS (DlPortWritePortUchar(CONT_ADDR,(control&=~0x02)))
  
//straight at the port
#define SET_RS (DlPortWritePortUchar(CONT_ADDR,(control|=0x04)))
#define CLR_RS (DlPortWritePortUchar(CONT_ADDR,(control&=~0x04)))

//inverted at the port
#define CLR_RES  (DlPortWritePortUchar(CONT_ADDR,(control|=0x08)))
#define SET_RES  (DlPortWritePortUchar(CONT_ADDR,(control&=~0x08)))

//inverted at the port
#define SET_E (DlPortWritePortUchar(CONT_ADDR,(control&=~0x01)));(Delay())
#define CLR_E (DlPortWritePortUchar(CONT_ADDR,(control|=0x01)))	;   // (ShortDelay())

#define STROBE_E SET_E; CLR_E

#define SDATA(x) (DlPortWritePortUchar(DATA_ADDR,(x)));(Sleep(20))

#define DATA(x) (DlPortWritePortUchar(DATA_ADDR,(x))); (Delay())

/////////////////////////////////////////////////////////////////////////////

BOOL CCFAG_WinTestDlg::OnInitDialog()
  {
  char
    string[10];
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	// set up scrolling timer
	SetTimer( ID_Timer, 106, NULL );


  //0 => 0x378, 1 => 0x278. 2 => 0x3BC
  m_address.SetCurSel(0);
  switch(m_address.GetCurSel())
    {
    case 1:
      port_data_address=0x278;
      break;
    case 2:
      port_data_address=0x3BC;
      break;
    default:
      port_data_address=0x378;
      break;
    }
  port_control_address=port_data_address+2;

	m_Shift_Slider.SetRange(0, 63);
	m_Shift_Slider.SetPos(last_shift=0);
  sprintf(string,"%d",last_shift);
	m_Shift_Setting.SetWindowText(string);


  //Idle the control lines
  SET_RES;
  CLR_E;
  CLR_RS;
  SET_CS;
  DATA(0);


	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCFAG_WinTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCFAG_WinTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCFAG_WinTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


////////////////////////////////////////////////////////////////////////////////////

void CCFAG_WinTestDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
  {
  }




void COM_W(ubyte data)
{
	DATA(data);
	SET_RS;
	CLR_CS;
	//R/W is hardwired low
	Sleep(10);
	SET_E;
	Sleep(10);
	CLR_E;
	Sleep(10);
	SET_CS;
}

void DATA_W(ubyte data)
{
	DATA(data);
	CLR_RS;
	CLR_CS;
	//R/W is hardwired low
	Sleep(10);
	SET_E;
	Sleep(10);
	CLR_E;
	Sleep(10);
	SET_CS;
}

void CP_COMMAND(ubyte comm_reg, ubyte data_reg)
{
	COM_W(comm_reg);
	DATA_W(data_reg);
}

void Show_Tractor(void)
  {
	int row,col;
	unsigned char *scrPtr;

	CP_COMMAND(0x0A,0x00); //Cursor low address setting
	CP_COMMAND(0x0B,0x00); //Cursor high address setting

	CLR_CS;
	SET_RS;	//Send data command
	DATA(0x0C);
	STROBE_E;
	CLR_RS;

	curRow = ((MAX_ROWS-1) - 128);
	scrPtr = (unsigned char *)screen128x128;
	scrPtr += (curRow<<4);		// 16 bytes per row

	for(row=0;row<=127;row++)
	{
		for(col=0;col<=15;col++)
		{
			DATA( *scrPtr++ );
			STROBE_E;
		}
	}
	SET_CS;

	Scrolling = TRUE;

}


void CCFAG_WinTestDlg::OnInitialize() 
  {
	CWaitCursor wait;


	Scrolling = FALSE;


	//0 => 0x378, 1 => 0x278. 2 => 0x3BC
	switch(m_address.GetCurSel())
	{
		case 1:
			port_data_address=0x278;
			break;
		case 2:
			port_data_address=0x3BC;
			break;
		default:
			port_data_address=0x378;
			break;
	}
	port_control_address=port_data_address+2;


	// testing
//	CLR_RES;
//	SET_RES;
//	CLR_E;
//	SET_E;
//	CLR_RS;
//	SET_RS;
//	CLR_CS;
//	SET_CS;




	//Idle the control lines & reset the display
	CLR_RES;
	CLR_E;
	CLR_RS;
	SET_CS;
//	DATA(0);
	Sleep(1);
	SET_RES;
	Sleep(1);

	// Command code--Mode control
	CP_COMMAND(0x00,0x32);	    //; set graphics mode

	// Character pitch setting
	CP_COMMAND(0x01,0x07);

	//Character number setting
	CP_COMMAND(0x02,15);            //;128/8=16 Char in one line


	// Display duty setting - Set 1/128 duty
	CP_COMMAND(0x03,127);

	// Display low address setting - Low address start from 00
	CP_COMMAND(0x08,0x00);

	// Display high address setting - High address start from 00
	CP_COMMAND(0x09,0x00);

	// Cursor low address setting - Low address start from 00
	CP_COMMAND(0x0A,0x00);

	// Cursor high address setting - High address start from 00
	CP_COMMAND(0x0B,0x00);

	int row,col;

	CLR_CS;
	SET_RS;
	DATA(0x0C);	//Send data command
	STROBE_E;
	CLR_RS;

	for(row=0;row<=127;row++)
		for(col=0;col<=15;col++)
		{
			DATA(0);
			STROBE_E;
		}

	SET_CS;
 }


void CCFAG_WinTestDlg::OnClear() 
  {
  CP_COMMAND(0x0A,0x00); //Cursor low address setting
  CP_COMMAND(0x0B,0x00); //Cursor high address setting
  int
    row,col;
  CLR_CS;
  //Send data command
  DATA(0x0C);
  SET_RS;
  //R/W is hardwired low
  SET_E;
  CLR_E;
  CLR_RS;
//  for(row=0;row<=159;row++)
  for(row=0;row<=127;row++)
    for(col=0;col<=15;col++)
      {
      DATA(0);
      //R/W is hardwired low
      SET_E;
      CLR_E;
      }
  SET_CS;
  }

void CCFAG_WinTestDlg::OnSet() 
  {
  CP_COMMAND(0x0A,0x00); //Cursor low address setting
  CP_COMMAND(0x0B,0x00); //Cursor high address setting
  int
    row,col;
  CLR_CS;
  //Send data command
  DATA(0x0C);
  SET_RS;
  //R/W is hardwired low
  SET_E;
  CLR_E;
  CLR_RS;
//  for(row=0;row<=159;row++)
  for(row=0;row<=127;row++)
    for(col=0;col<=15;col++)
      {
      DATA(0xFF);
      //R/W is hardwired low
      SET_E;
      CLR_E;
      }
  SET_CS;
  }

void Show_Sophie(void)
  {
  CP_COMMAND(0x0A,0x00); //Cursor low address setting
  CP_COMMAND(0x0B,0x00); //Cursor high address setting
  int
    row,col;
  CLR_CS;
  //Send data command
  DATA(0x0C);
  SET_RS;
  //R/W is hardwired low
  SET_E;
  CLR_E;
  CLR_RS;
//  for(row=0;row<=159;row++)
  for(row=0;row<=127;row++)
    for(col=0;col<=15;col++)
      {
      DATA(sophie_240_128[row][col]);
      //R/W is hardwired low
      SET_E;
      CLR_E;
      }
  SET_CS;
  }

void CCFAG_WinTestDlg::OnCheckerboard() 
  {
  CP_COMMAND(0x0A,0x00); //Cursor low address setting
  CP_COMMAND(0x0B,0x00); //Cursor high address setting
  int
    row,col;
  CLR_CS;
  //Send data command
  DATA(0x0C);
  SET_RS;
  //R/W is hardwired low
  SET_E;
  CLR_E;
  CLR_RS;
//  for(row=0;row<=159;row++)
  for(row=0;row<=127;row++)
    for(col=0;col<=15;col++)
      {
      if((row&0x01)==0)
	    {
        DATA(0xAA);
	    }
      else
        DATA(0x55);
      //R/W is hardwired low
      SET_E;
      CLR_E;
      }
  SET_CS;
  }

void CCFAG_WinTestDlg::OnHStripes() 
  {
  CP_COMMAND(0x0A,0x00); //Cursor low address setting
  CP_COMMAND(0x0B,0x00); //Cursor high address setting
  int
    row,col;
  CLR_CS;
  //Send data command
  DATA(0x0C);
  SET_RS;
  //R/W is hardwired low
  SET_E;
  CLR_E;
  CLR_RS;
//  for(row=0;row<=159;row++)
  for(row=0;row<=127;row++)
    for(col=0;col<=15;col++)
      {
      if((row&0x01)==0)
	    {
        DATA(0xFF);
		}
      else
        DATA(0x00);
      //R/W is hardwired low
      SET_E;
      CLR_E;
      }
  SET_CS;
  }

void CCFAG_WinTestDlg::OnVStripes() 
  {
  CP_COMMAND(0x0A,0x00); //Cursor low address setting
  CP_COMMAND(0x0B,0x00); //Cursor high address setting
  int
    row,col;
  CLR_CS;
  //Send data command
  DATA(0x0C);
  SET_RS;
  //R/W is hardwired low
  SET_E;
  CLR_E;
  CLR_RS;
//  for(row=0;row<=159;row++)
  for(row=0;row<=127;row++)
    for(col=0;col<=15;col++)
      {
      DATA(0xAA);
      //R/W is hardwired low
      SET_E;
      CLR_E;
      }
  SET_CS;
  }

void CCFAG_WinTestDlg::OnDiagonals() 
  {

  CP_COMMAND(0x0A,0x00); //Cursor low address setting
  CP_COMMAND(0x0B,0x00); //Cursor high address setting
  int
    row,col;
  CLR_CS;

  //Send data command
  DATA(0x0C);
  SET_RS;
  //R/W is hardwired low
  SET_E;
  CLR_E;
  CLR_RS;

//  for(row=0;row<=159;row++)
  for(row=0;row<=127;row++)
    for(col=0;col<=15;col++)
      {
      DATA(0x333>>(row&0x03));
      //R/W is hardwired low
      SET_E;
      CLR_E;
      }
  SET_CS;
}

void CCFAG_WinTestDlg::OnTractor() 
  {
  Show_Tractor();
  }

void CCFAG_WinTestDlg::OnOnBaxter() 
{
  Show_Sophie();		
}

void CCFAG_WinTestDlg::OnLogo() 
{

  //Talk to both controllers
  CLR_CS;

  int
    row;
  for(row=0;row<=7;row++)
    {
    //Set X address
    DATA(0xB8|row);
    SET_E;
    CLR_E;
    Sleep(10);

    //Set Y address 0
    DATA(0x40);
    SET_E;
    CLR_E;
    Sleep(10);

    //Aim at the data register.
    SET_RS;

    //Talk to controller 1 only
    SET_CS;

    int
      col;
    for(col=0;col<=63;col++)
      {
      //DATA(cfag12864b[row][col]);
		  SET_E;
      Sleep(10);
		  CLR_E;
      Sleep(10);
      }

    //Talk to the controller 2
    CLR_CS;

    for(col=64;col<=127;col++)
      {
      //DATA(cfag12864b[row][col]);
		  SET_E;
      Sleep(10);
		  CLR_E;
      Sleep(10);
      }
    
    //Talk to both controllers
    CLR_CS;

    //Aim back to the control register.
    CLR_RS;
    }

}

void CCFAG_WinTestDlg::OnEditchangeDevice() 
  {

  }

void CCFAG_WinTestDlg::OnEditchangeAddress() 
  {

  }


void CCFAG_WinTestDlg::OnShowText() 
  {
  //MOV     COMM_REG,#00H           ;Command code--Mode control
  //MOV     DATA_REG,#30H           ;Set 00110010
  //LCALL   CP_COMMAND              ;Command complete
  CP_COMMAND(0x00,0x30);


  //MOV     COMM_REG,#01H           ;Character pitch setting
  //MOV     DATA_REG,#77H           ;Set 10010111
  //LCALL   CP_COMMAND              ;Command complete
  CP_COMMAND(0x01,0x75);            //5x7 font on a 6x8 matrix 

  //MOV     COMM_REG,#02H           ;Character number setting
  //MOV     DATA_REG,#39            ;160/6=26 Char in one line
  //LCALL   CP_COMMAND              ;Command complete
//  CP_COMMAND(0x02,27);
  CP_COMMAND(0x02,22);             //;128/6=21 Char in one line


  //MOV     COMM_REG,#0AH           ;Cursor low address setting
  //MOV     DATA_REG,#00H           ;Low address start from 00H
  //LCALL   CP_COMMAND              ;Command complete
  CP_COMMAND(0x0A,0x00);

  //MOV     COMM_REG,#0BH           ;Cursor high address setting
  //MOV     DATA_REG,#00H           ;High address start from 00
  //LCALL   CP_COMMAND              ;Command complete
  CP_COMMAND(0x0B,0x00);

  int
    row,col;

  CLR_CS;
  //Send data command
  DATA(0x0C);
  SET_RS;
  //R/W is hardwired low
  SET_E;
  CLR_E;
  CLR_RS;
  for(row=0;row<=28;row++)
    for(col=0;col<=27;col++)
      {
      DATA(Text_Screen[row][col]);
      //R/W is hardwired low
      SET_E;
      CLR_E;
      }
  SET_CS;
  }

void CCFAG_WinTestDlg::OnClearText() 
  {
  //MOV     COMM_REG,#00H           ;Command code--Mode control
  //MOV     DATA_REG,#30H           ;Set 00110010
  //LCALL   CP_COMMAND              ;Command complete
  CP_COMMAND(0x00,0x30);


  //MOV     COMM_REG,#01H           ;Character pitch setting
  //MOV     DATA_REG,#77H           ;Set 10010111
  //LCALL   CP_COMMAND              ;Command complete
  CP_COMMAND(0x01,0x75);            //5x7 font on a 6x8 matrix 

  //MOV     COMM_REG,#02H           ;Character number setting
  //MOV     DATA_REG,#39            ;240/6=40 Char in one line
  //LCALL   CP_COMMAND              ;Command complete
  CP_COMMAND(0x02,39);


  //MOV     COMM_REG,#0AH           ;Cursor low address setting
  //MOV     DATA_REG,#00H           ;Low address start from 00H
  //LCALL   CP_COMMAND              ;Command complete
  CP_COMMAND(0x0A,0x00);

  //MOV     COMM_REG,#0BH           ;Cursor high address setting
  //MOV     DATA_REG,#00H           ;High address start from 00
  //LCALL   CP_COMMAND              ;Command complete
  CP_COMMAND(0x0B,0x00);

  int
    row,col;

  CLR_CS;
  //Send data command
  DATA(0x0C);
  SET_RS;
  //R/W is hardwired low
  SET_E;
  CLR_E;
  CLR_RS;
  for(row=0;row<=28;row++)
    for(col=0;col<=27;col++)
      {
      DATA(' ');
      //R/W is hardwired low
      SET_E;
      CLR_E;
      }
  SET_CS;
  }

void CCFAG_WinTestDlg::OnSecondLayerButton() 
  {
  }

void CCFAG_WinTestDlg::OnClose() 
{
	KillTimer( ID_Timer );
	CDialog::OnClose();
}


void CCFAG_WinTestDlg::OnTimer(UINT nIDEvent) 
{
	unsigned char *scrPtr;
	int row, col;

	if( Scrolling ) {

		if( curRow ) {
			curRow--;
		} else {
			if( MAX_ROWS > 128 ) {
				curRow = ((MAX_ROWS-1) - 128);
			}
		}

		scrPtr = (unsigned char *)screen128x128;
		scrPtr += (curRow<<4);		// 16 bytes per row

		CLR_CS;
		for(row=0;row<=127;row++)
		{
			for(col=0;col<=15;col++)
			{
				DATA( *scrPtr++ );
				STROBE_E;
			}
		}
		SET_CS;
		

	}

	
	CDialog::OnTimer(nIDEvent);
}
